"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PdfViewer = void 0;
// @ts-ignore-next-line
var pdf_viewer_1 = require("pdfjs-dist/web/pdf_viewer");
require("pdfjs-dist/web/pdf_viewer.css");
var react_1 = __importStar(require("react"));
require("../style/pdf_viewer.css");
var utils_1 = require("../utils");
var coordinates_1 = require("../utils/coordinates");
var AreaSelection_1 = require("./AreaSelection");
var NewAreaSelection_1 = require("./NewAreaSelection");
var TextSelection_1 = require("./TextSelection");
var isAreaSelection = function (selection) { return "image" in selection; };
var PdfViewer = /** @class */ (function (_super) {
    __extends(PdfViewer, _super);
    function PdfViewer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            pageHeights: [],
            pageMargin: 0,
            textSelectionEnabled: true,
        };
        _this.eventBus = new pdf_viewer_1.EventBus();
        _this.linkService = new pdf_viewer_1.PDFLinkService({ eventBus: _this.eventBus });
        _this.pdfContainerRefCallback = function (ref) {
            if (ref) {
                _this.setState({ containerNode: ref }, function () { return _this.mountDocument(); });
            }
        };
        _this.getPageOffset = function (pageNumber) {
            var _a = _this.state, pageHeights = _a.pageHeights, pageMargin = _a.pageMargin;
            return pageHeights.slice(0, pageNumber - 1).reduce(function (a, b) { return a + b + pageMargin; }, 0);
        };
        _this.containerCoords = function (pageX, pageY) {
            if (!_this.state.containerNode)
                return;
            return {
                x: pageX - _this.state.containerNode.offsetLeft,
                y: pageY - _this.state.containerNode.offsetTop,
            };
        };
        _this.rectsToLayout = function (page, rects) {
            return rects.map(function (rect) {
                var style = utils_1.getWindow(page.node).getComputedStyle(page.node);
                var offsetLeft = parseInt(style.borderLeftWidth, 10) + parseInt(style.paddingLeft, 10);
                var offsetTopPage = parseInt(style.borderTopWidth, 10) + parseInt(style.paddingTop, 10);
                var pageOffset = _this.getPageOffset(page.number);
                var offsetTop = pageOffset > 0 ? pageOffset - _this.state.pageMargin + offsetTopPage : offsetTopPage;
                return __assign(__assign({}, rect), { left: rect.left + offsetLeft, top: rect.top + offsetTop });
            });
        };
        _this.resize = function () {
            if (!_this.state.viewer)
                return;
            var page = _this.state.viewer.viewer.firstElementChild;
            if (!page)
                return;
            _this.state.viewer.currentScaleValue = "page-width";
            var style = utils_1.getWindow(page).getComputedStyle(page);
            var layoutProperties = ["marginTop", "marginBottom", "borderTopWidth", "borderBottomWidth", "paddingTop", "paddingBottom"];
            var pageMargin = layoutProperties.map(function (prop) { return parseInt(style[prop], 10); }).reduce(function (a, b) { return a + b; }, 0);
            var pageHeights = Array.from(_this.state.viewer.viewer.childNodes).map(function (page) { return page.clientHeight; });
            _this.setState({ pageHeights: pageHeights, pageMargin: pageMargin });
        };
        _this.resetSelections = function () {
            var _a, _b, _c, _d;
            (_b = (_a = _this.props).onTextSelection) === null || _b === void 0 ? void 0 : _b.call(_a);
            (_d = (_c = _this.props).onAreaSelection) === null || _d === void 0 ? void 0 : _d.call(_c);
            _this.setState({ areaSelection: undefined, textSelectionEnabled: true });
        };
        _this.onSelectionChange = function () {
            var _a, _b;
            if (!_this.state.viewer)
                return;
            var selection = utils_1.getWindow(_this.state.containerNode).getSelection();
            if (!selection || selection.isCollapsed)
                return;
            var range = selection.rangeCount > 0 ? selection.getRangeAt(0) : undefined;
            if (!range)
                return;
            var page = utils_1.getPageFromRange(range);
            if (!page)
                return;
            var pageOffset = _this.getPageOffset(page.number);
            var rects = utils_1.getClientRects(range, page.node);
            if (rects.length === 0)
                return;
            var pageRects = _this.rectsToLayout(page, rects);
            var viewport = { width: page.node.clientWidth, height: page.node.clientHeight, pageOffset: pageOffset };
            var boundingRect = utils_1.getBoundingRect(pageRects);
            var position = coordinates_1.normalizePosition({ boundingRect: boundingRect, rects: pageRects, pageNumber: page.number }, viewport);
            var text = Array.from(range.cloneContents().childNodes).reduce(function (a, b) { return a + " " + b.textContent; }, "");
            (_b = (_a = _this.props).onTextSelection) === null || _b === void 0 ? void 0 : _b.call(_a, { position: position, text: text });
        };
        _this.onAreaSelectStart = function (event) {
            _this.setState({ textSelectionEnabled: false });
            var start = _this.containerCoords(event.pageX, event.pageY);
            if (!start)
                return;
            _this.setState({
                areaSelection: { originTarget: event.target, start: start, locked: false },
            });
        };
        _this.getAreaSelectionPosition = function (event) {
            var areaSelection = _this.state.areaSelection;
            if (!areaSelection || !areaSelection.originTarget || !areaSelection.start || areaSelection.locked)
                return;
            var end = _this.containerCoords(event.pageX, event.pageY);
            if (!end)
                return;
            var page = utils_1.getPageFromElement(areaSelection.originTarget);
            if (!page)
                return;
            var pageOffset = _this.getPageOffset(page.number);
            var viewport = { width: page.node.clientWidth, height: page.node.clientHeight, pageOffset: pageOffset };
            var boundingRect = _this.getBoundingRect(areaSelection.start, end);
            return coordinates_1.normalizePosition({ boundingRect: boundingRect, rects: [boundingRect], pageNumber: page.number }, viewport);
        };
        _this.onAreaSelectChange = function (event) {
            var areaSelection = _this.state.areaSelection;
            var position = _this.getAreaSelectionPosition(event);
            if (!position)
                return;
            _this.setState({ areaSelection: __assign(__assign({}, areaSelection), { position: position }) });
        };
        _this.onAreaSelectEnd = function (event) {
            var _a, _b;
            var areaSelection = _this.state.areaSelection;
            if (!_this.state.viewer)
                return;
            var position = _this.getAreaSelectionPosition(event);
            if (!position)
                return;
            var pageView = _this.state.viewer.getPageView(position.pageNumber - 1);
            if (!pageView)
                return;
            var image = utils_1.getAreaAsPNG(pageView.canvas, position.relative.boundingRect);
            (_b = (_a = _this.props).onAreaSelection) === null || _b === void 0 ? void 0 : _b.call(_a, { position: position, image: image });
            _this.setState({
                areaSelection: __assign(__assign({}, areaSelection), { position: position, locked: true }),
                textSelectionEnabled: true,
            });
        };
        _this.onMouseDown = function (event) {
            var _a, _b;
            _this.resetSelections();
            if (!((_b = (_a = _this.props).enableAreaSelection) === null || _b === void 0 ? void 0 : _b.call(_a, event)))
                return;
            document.addEventListener("pointermove", _this.onMouseMove);
            document.addEventListener("pointerup", _this.onMouseUp);
            event.preventDefault();
            event.stopPropagation();
            _this.onAreaSelectStart(event);
        };
        _this.onMouseMove = function (event) {
            event.stopPropagation();
            _this.onAreaSelectChange(event);
        };
        _this.onMouseUp = function (event) {
            document.removeEventListener("pointermove", _this.onMouseMove);
            document.removeEventListener("pointerup", _this.onMouseUp);
            event.stopPropagation();
            _this.onAreaSelectEnd(event);
        };
        _this.onKeyDown = function (event) {
            var _a, _b;
            if (event.code === "Escape")
                (_b = (_a = _this.props).onTextSelection) === null || _b === void 0 ? void 0 : _b.call(_a);
        };
        _this.addEventListeners = function () {
            var _a;
            _this.eventBus.on("pagesinit", _this.resize);
            document.addEventListener("keydown", _this.onKeyDown);
            document.addEventListener("selectionchange", _this.onSelectionChange);
            (_a = document.defaultView) === null || _a === void 0 ? void 0 : _a.addEventListener("resize", _this.resize);
        };
        _this.removeEventListeners = function () {
            var _a;
            _this.eventBus.off("pagesinit", _this.resize);
            document.removeEventListener("keydown", _this.onKeyDown);
            document.removeEventListener("selectionchange", _this.onSelectionChange);
            (_a = document.defaultView) === null || _a === void 0 ? void 0 : _a.removeEventListener("resize", _this.resize);
        };
        _this.mountDocument = function () {
            _this.removeEventListeners();
            var viewer = _this.state.viewer ||
                new pdf_viewer_1.PDFViewer({
                    container: _this.state.containerNode,
                    eventBus: _this.eventBus,
                    enhanceTextSelection: true,
                    linkService: _this.linkService,
                });
            _this.linkService.setDocument(_this.props.pdfDocument);
            _this.linkService.setViewer(viewer);
            viewer.setDocument(_this.props.pdfDocument);
            _this.setState({ viewer: viewer });
            _this.addEventListeners();
            // debug
            window.PdfViewer = _this;
        };
        _this.getPageViewport = function (pageNumber) {
            if (!_this.state.viewer)
                return;
            var pageView = _this.state.viewer.getPageView(pageNumber - 1);
            if (!pageView)
                return;
            return __assign(__assign({}, pageView.viewport), { pageOffset: _this.getPageOffset(pageNumber) });
        };
        _this.renderSelection = function (selection, i) {
            var pageViewport = _this.getPageViewport(selection.position.pageNumber);
            if (!pageViewport)
                return null;
            var normalizedSelection = __assign(__assign({}, selection), { position: utils_1.positionToViewport(selection.position, pageViewport) });
            return isAreaSelection(normalizedSelection) ? (react_1.default.createElement(AreaSelection_1.AreaSelection, { key: i, areaSelection: normalizedSelection })) : (react_1.default.createElement(TextSelection_1.TextSelection, { key: i, textSelection: normalizedSelection }));
        };
        _this.render = function () {
            var _a, _b, _c;
            var newAreaViewport = ((_a = _this.state.areaSelection) === null || _a === void 0 ? void 0 : _a.position) ? _this.getPageViewport(_this.state.areaSelection.position.pageNumber)
                : undefined;
            return (react_1.default.createElement("div", { ref: _this.pdfContainerRefCallback, className: "pdfViewerContainer", style: __assign({ position: "relative" }, (_this.state.textSelectionEnabled
                    ? {}
                    : {
                        userSelect: "none",
                        pointerEvents: "none",
                    })), onContextMenu: function (e) { return e.preventDefault(); }, onPointerDown: _this.onMouseDown },
                react_1.default.createElement("div", { className: "pdfViewer" }),
                react_1.default.createElement("div", { className: "pdfViewer__area-selection" }, ((_b = _this.state.areaSelection) === null || _b === void 0 ? void 0 : _b.position) && newAreaViewport && (react_1.default.createElement(NewAreaSelection_1.NewAreaSelection, { position: utils_1.viewportPosition(_this.state.areaSelection.position, newAreaViewport) }))),
                react_1.default.createElement("div", null, (_c = _this.props.selections) === null || _c === void 0 ? void 0 : _c.map(function (selection, i) {
                    return _this.renderSelection(selection, i);
                })),
                _this.props.children));
        };
        return _this;
    }
    PdfViewer.prototype.getBoundingRect = function (start, end) {
        return {
            left: Math.min(end.x, start.x),
            top: Math.min(end.y, start.y),
            width: Math.abs(end.x - start.x),
            height: Math.abs(end.y - start.y),
        };
    };
    PdfViewer.prototype.componentDidUpdate = function (prevProps) {
        if (prevProps.pdfDocument !== this.props.pdfDocument) {
            this.mountDocument();
            return;
        }
    };
    return PdfViewer;
}(react_1.Component));
exports.PdfViewer = PdfViewer;
