import { PDFDocumentProxy, PDFPageViewport } from "pdfjs-dist";
export declare type BoundingRect = {
    left: number;
    top: number;
    width: number;
    height: number;
};
export declare type SelectionRects = {
    boundingRect: BoundingRect;
    rects: Array<BoundingRect>;
};
export declare type Position = {
    pageNumber: number;
} & SelectionRects;
export declare type NormalizedPosition = {
    absolute: SelectionRects;
    relative: SelectionRects;
    normalized: SelectionRects;
    pageNumber: number;
};
export declare type EventBus = {
    on: (eventName: string, callback: () => void) => void;
    off: (eventName: string, callback: () => void) => void;
};
export declare type Viewer = {
    container: HTMLDivElement;
    viewer: HTMLDivElement;
    getPageView: (page: number) => {
        textLayer: {
            textLayerDiv: HTMLDivElement;
        };
        viewport: PDFPageViewport;
        div: HTMLDivElement;
        canvas: HTMLCanvasElement;
    } | undefined;
    setDocument: (document: PDFDocumentProxy) => Promise<void>;
    scrollPageIntoView: (options: {
        pageNumber: number;
        destArray: Array<any>;
    }) => void;
    currentScaleValue: string;
};
export declare type LinkService = {
    setDocument: (document: Object) => void;
    setViewer: (viewer: Viewer) => void;
};
