"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.viewportPosition = exports.positionToViewport = exports.viewportBoundingRect = exports.normalizePosition = exports.normalizeBoundingRect = exports.relativizeBoundingRect = void 0;
var relativizeBoundingRect = function (rect, _a) {
    var pageOffset = _a.pageOffset;
    return __assign(__assign({}, rect), { top: rect.top - pageOffset });
};
exports.relativizeBoundingRect = relativizeBoundingRect;
var normalizeBoundingRect = function (rect, _a) {
    var width = _a.width, height = _a.height, pageOffset = _a.pageOffset;
    return {
        left: rect.left / width,
        top: (rect.top - pageOffset) / height,
        width: rect.width / width,
        height: rect.height / height,
    };
};
exports.normalizeBoundingRect = normalizeBoundingRect;
var normalizePosition = function (position, viewport) {
    return {
        absolute: {
            boundingRect: position.boundingRect,
            rects: position.rects,
        },
        relative: {
            boundingRect: exports.relativizeBoundingRect(position.boundingRect, viewport),
            rects: position.rects.map(function (rect) { return exports.relativizeBoundingRect(rect, viewport); }),
        },
        normalized: {
            boundingRect: exports.normalizeBoundingRect(position.boundingRect, viewport),
            rects: position.rects.map(function (rect) { return exports.normalizeBoundingRect(rect, viewport); }),
        },
        pageNumber: position.pageNumber,
    };
};
exports.normalizePosition = normalizePosition;
var viewportBoundingRect = function (rect, _a) {
    var width = _a.width, height = _a.height, pageOffset = _a.pageOffset;
    return {
        left: rect.left * width,
        top: rect.top * height + pageOffset,
        width: rect.width * width,
        height: rect.height * height,
    };
};
exports.viewportBoundingRect = viewportBoundingRect;
var positionToViewport = function (position, viewport) {
    return {
        boundingRect: exports.viewportBoundingRect(position.boundingRect, viewport),
        rects: position.rects.map(function (rect) { return exports.viewportBoundingRect(rect, viewport); }),
        pageNumber: position.pageNumber,
    };
};
exports.positionToViewport = positionToViewport;
var viewportPosition = function (position, viewport) {
    return {
        boundingRect: exports.viewportBoundingRect(position.normalized.boundingRect, viewport),
        rects: position.normalized.rects.map(function (rect) { return exports.viewportBoundingRect(rect, viewport); }),
        pageNumber: position.pageNumber,
    };
};
exports.viewportPosition = viewportPosition;
